SystemOrganization addCategory: #'PolySource-Core'!
SystemOrganization addCategory: #'PolySource-Model'!
SystemOrganization addCategory: #'PolySource-Morphic'!
SystemOrganization addCategory: #'PolySource-Network'!
SystemOrganization addCategory: #'PolySource-Tests'!
SystemOrganization addCategory: #'PolySource-Dialogs'!

SystemDictionary subclass: #PSSystemDictionary
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionary commentStamp: 'mt 8/29/2010 19:23:48.53' prior: 0!
I am a copy of the local SystemDictionary (Smalltalk globals) but I do not copy the classes. I provide my own organization.!

!PSSystemDictionary methodsFor: 'initialize' stamp: 'mig 8/9/2010 15:00:32.549'!
initialize: size

	super initialize: size.
	Smalltalk globals keysAndValuesDo: [ :key :value |
		self at: key put: value].! !

!SystemDictionary methodsFor: '*polysource-core' stamp: 'mt 8/29/2010 19:32:52.227'!
isProxy

	^ false! !

Dictionary subclass: #PSFixtures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

PSFixtures class
	instanceVariableNames: 'instance'!

PSFixtures class
	instanceVariableNames: 'instance'!

!PSFixtures class methodsFor: 'accessing' stamp: 'mig 8/9/2010 17:30:19.665'!
at: key

	^ self instance at: key! !

!PSFixtures class methodsFor: 'accessing' stamp: 'mig 8/9/2010 17:30:01.619'!
at: key put: value
.
	^ self instance at: key put: value! !

!PSFixtures class methodsFor: 'examples' stamp: 'mt 9/6/2010 11:46:25.931'!
example01

	"Need a proxy to get the class compiled into the right dictionary."
	PSSystemDictionaryProxy install.

	PSCurrentRemoteClient
		value: (PSFixtures at: #example01 put: PSRemoteClient new)
		during: [Object
			subclass: #PSFoobar
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'PolySource-Tests-Temporary'].

	"Test data prepared. Clean up."
	Smalltalk globals uninstall.! !

!PSFixtures class methodsFor: 'testing' stamp: 'mig 8/25/2010 13:53:39.589'!
includesKey: key

	^ self instance includesKey: key! !

!PSFixtures class methodsFor: 'singleton' stamp: 'mig 8/9/2010 17:29:05.257'!
instance

	^ instance ifNil: [instance := self new]! !

PasteUpMorph subclass: #PSRemoteWorld
	instanceVariableNames: 'remoteClient infoLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteWorld commentStamp: 'mt 9/7/2010 12:15:36.029' prior: 0!
A remote world has a remote world state and a remote client. =D!

!PSRemoteWorld class methodsFor: 'project' stamp: 'mt 9/7/2010 12:03:27.714'!
newWorldForProject: projectOrNil 

	^ self new initForProject: PSRemoteWorldState new! !

!PSRemoteWorld methodsFor: 'initialize' stamp: 'mt 9/7/2010 13:12:04.365'!
initialize

	super initialize.
	self
		color: (Color gray: 0.8);
		borderWidth: 0.
		
	infoLabel := TextMorph new lock.
	self addMorphBack: infoLabel.
	infoLabel topLeft: self topLeft + (20@50).
	
	self connect: self signal: #remoteClient: toSelector: #updateInfoLabel.
	self updateInfoLabel.! !

!PSRemoteWorld methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:26:10.299'!
remoteClient

	^ remoteClient! !

!PSRemoteWorld methodsFor: 'accessing' stamp: 'mt 9/7/2010 12:18:58.166'!
remoteClient: aRemoteClient

	remoteClient := aRemoteClient.! !

!PSRemoteWorld methodsFor: 'initialize' stamp: 'mt 9/7/2010 13:13:07.697'!
updateInfoLabel

	infoLabel contents: 
		(self remoteClient
			ifNil: ['<font size="12" color="#FF0000"><b>No remote client configured.</b></font>' asHtmlText]
			ifNotNil: ['']).! !

!PSRemoteWorld methodsFor: 'accessing' stamp: 'mt 9/7/2010 13:15:56.106'!
worldState
	"Needed to grant access to deferred UI message queue. See PSRemoteWorldState>>deferredUIMessages."
	
	^ worldState! !

!Class methodsFor: '*polysource-core-override' stamp: 'mig 9/8/2010 13:57:33.439'!
environment

	^ Smalltalk globals
	"PolySource modifcation:
	Do not allow to store a class-local environment to be able to switch the globals. Old code was:
	
	environment == nil ifTrue: [^ super environment].
	^ environment
	"! !

!SystemEventManager methodsFor: '*polysource-core' stamp: 'mt 9/9/2010 14:53:23.684'!
actionMap

	^ PSCurrentRemoteClient value
		ifNil: [super actionMap]
		ifNotNil: [PSCurrentRemoteClient value systemEventActionMap]! !

!SystemEventManager methodsFor: '*polysource-core' stamp: 'mt 9/9/2010 14:54:24.674'!
updateableActionMap

	^ PSCurrentRemoteClient value
		ifNil: [super updateableActionMap]
		ifNotNil: [PSCurrentRemoteClient value systemEventActionMap]! !

SqEntity subclass: #PSSourceCode
	instanceVariableNames: 'uuid snapshot updates packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSSourceCode methodsFor: 'add/remove' stamp: 'mt 9/10/2010 10:56:01.276'!
addPackage: aSymbol

	self packages add: aSymbol.
	dummy := #packageAdded.
	self packageAdded: aSymbol.! !

!PSSourceCode methodsFor: 'add/remove' stamp: 'mt 9/8/2010 09:20:56.673'!
addUpdate: aCodeUpdate

	self updates add: aCodeUpdate.
	dummy := #updateAdded.
	self updateAdded: aCodeUpdate.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:15:34.574'!
categories

	^ self packages
		inject: OrderedCollection new
		into: [:categories :package | 
			categories addAll: (PackageInfo named: package) systemCategories]! !

!PSSourceCode methodsFor: 'initialize' stamp: 'mt 9/10/2010 11:20:51.752'!
initialize

	super initialize.

	packages := OrderedCollection new.
	updates := OrderedCollection new.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/10/2010 10:55:18.753'!
packageAdded: aSymbol

	self emitAlways.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/10/2010 10:55:24.035'!
packageRemoved: aSymbol

	self emitAlways.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/10/2010 10:56:11.02'!
packages

	^ packages! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:26:57.291'!
snapshot

	^ snapshot! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/8/2010 09:19:56.387'!
snapshot: aCodeSnapshot

	snapshot := aCodeSnapshot.
	updates := OrderedCollection new.
	self snapshotChanged: snapshot.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/8/2010 09:19:43.855'!
snapshotChanged: newSnapshot

	self emitAlways.! !

!PSSourceCode methodsFor: 'signals' stamp: 'mt 9/8/2010 09:20:46.905'!
updateAdded: anUpdate

	self emitAlways.! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 9/7/2010 14:40:19.878'!
updates

	^ updates! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 8/30/2010 15:26:59.314'!
uuid

	^ uuid! !

!PSSourceCode methodsFor: 'accessing' stamp: 'mt 8/30/2010 15:27:09.666'!
uuid: aUUID

	uuid := aUUID.! !

SqEntity subclass: #PSSourceCodeRepository
	instanceVariableNames: 'sourceCodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSSourceCodeRepository methodsFor: 'add/remove' stamp: 'mt 9/8/2010 10:06:08.005'!
addSourceCode: aSourceCode

	self sourceCodes add: aSourceCode.
	dummy := #sourceCodeAdded.
	self sourceCodeAdded: aSourceCode.
	^ aSourceCode! !

!PSSourceCodeRepository methodsFor: 'initialize-release' stamp: 'mt 9/7/2010 14:39:21.48'!
initialize

	super initialize.
	sourceCodes := OrderedCollection new.! !

!PSSourceCodeRepository methodsFor: 'add/remove' stamp: 'mt 9/8/2010 10:06:59.002'!
removeSourceCode: aSourceCode

	self sourceCode remove: aSourceCode ifAbsent: [^ self].
	dummy := #sourceCodeRemoved.
	self sourceCodeRemoved: aSourceCode.
	^ aSourceCode! !

!PSSourceCodeRepository methodsFor: 'signals' stamp: 'mt 9/8/2010 10:05:52.445'!
sourceCodeAdded: aSourceCode

	self emitAlways.! !

!PSSourceCodeRepository methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:24:32.092'!
sourceCodeByID: aUUID

	^ self sourceCodes
		detect: [:c | c uuid = aUUID]
		ifNone: [self addSourceCode: (PSSourceCode new uuid: aUUID)]! !

!PSSourceCodeRepository methodsFor: 'signals' stamp: 'mt 9/8/2010 10:06:42.983'!
sourceCodeRemoved: aSourceCode

	self emitAlways.! !

!PSSourceCodeRepository methodsFor: 'accessing' stamp: 'mt 9/7/2010 14:39:10.491'!
sourceCodes

	^ sourceCodes! !

SqEntity subclass: #PSSourceCodeUpdate
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/8/2010 08:48:39.234'!
event
	
	^ event! !

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/9/2010 10:03:15.36'!
event: aSystemEvent
	
	event := aSystemEvent.! !

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/7/2010 19:48:34.865'!
eventItemClass

	^ (self event instVarNamed: #environment) at: AbstractEvent classKind! !

!PSSourceCodeUpdate methodsFor: 'accessing' stamp: 'mt 9/7/2010 19:48:44.886'!
eventItemMethod

	^ (self event instVarNamed: #environment) at: AbstractEvent methodKind! !

Object subclass: #PSSourceCodeClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

!PSSourceCodeClient commentStamp: 'mt 9/8/2010 09:21:39.726' prior: 0!
I am an abstract base class that offers convenient update and filein capabilities for source codes.!

PSSourceCodeClient subclass: #PSLocalClient
	instanceVariableNames: 'uuid connection remoteClients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

PSLocalClient class
	instanceVariableNames: 'instance'!

!PSLocalClient commentStamp: 'mig 9/8/2010 14:00:05.641' prior: 0!
I respresent a local PolySource "application". I hold information about the local system (UUID etc.) and the SqSync client.!

PSLocalClient class
	instanceVariableNames: 'instance'!

!PSLocalClient class methodsFor: 'instance' stamp: 'mt 9/7/2010 10:06:47.765'!
instance
	"This is the instance of PSLocalClient that has to be (re-)used in a normal application. Tests are allowed to create further instances with own SqSync connections and UUIDs."
	
	^ instance ifNil: [instance := self new]! !

!PSLocalClient class methodsFor: 'instance' stamp: 'mt 9/8/2010 11:58:34.927'!
reset
	
	instance disconnect.
	instance becomeForward: self new.
	instance uuid.! !

!PSLocalClient methodsFor: 'remote client handling' stamp: 'mt 9/9/2010 09:51:44.806'!
addRemoteClient: aSourceCode

	self remoteClients add: (PSRemoteClient new sourceCode: aSourceCode).
	self remoteClientAdded: self remoteClients last.
! !

!PSLocalClient methodsFor: 'networking' stamp: 'mt 9/8/2010 10:56:20.743'!
connectTo: aHostnameOrAddressString

	self disconnect.
		
	self connection: (SyClient new
		connectToHostNamed: aHostnameOrAddressString
		port: 22701).
		
	self connected.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/8/2010 10:55:59.05'!
connected

	self emit.! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 8/30/2010 15:34:56.859'!
connection

	^ connection! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:39:21.62'!
connection: anSyClient

	connection := anSyClient.
	
	connection ifNil: [^ self].
	
	"Assure the root object resp. source code repository."
	connection repository rootObject
		ifNil: [connection repository rootObject: PSSourceCodeRepository new].
	
	self createRemoteClients.
	
	self connect: self repository signal: #sourceCodeAdded: toSelector: #addRemoteClient:.
	self connect: self repository signal: #sourceCodeRemoved: toSelector: #removeRemoteClient:.
	
	"Process external updates for me."
	self connect: self sourceCode signal: #updateAdded: toSelector: #executeUpdateSilently:.
	self connect: self sourceCode signal: #snapshotChanged: toSelector: #fileInSnapshot.
! !

!PSLocalClient methodsFor: 'remote client handling' stamp: 'mig 9/8/2010 15:12:20.18'!
createRemoteClients

	self remoteClients: (self connection repository rootObject sourceCodes
		select: [:sc | sc uuid asString ~= self uuid asString]
		thenCollect: [:sc | PSRemoteClient new sourceCode: sc]).
! !

!PSLocalClient methodsFor: 'notifications' stamp: 'mt 9/7/2010 15:30:26.088'!
disableNotificationProcessing

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self.! !

!PSLocalClient methodsFor: 'networking' stamp: 'mt 9/9/2010 09:58:38.223'!
disconnect

	connection ifNil: [^ self].
	
	"Update the source code before disconnect."
	self updateSnapshot.
	
	"Disconnect."
	connection disconnect.
	connection := nil.
		
	self disconnected.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/8/2010 10:56:01.81'!
disconnected

	self emit.! !

!PSLocalClient methodsFor: 'notifications' stamp: 'mt 9/7/2010 15:30:53.685'!
enableNotificationProcessing

	SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:.! !

!PSLocalClient methodsFor: 'update handling' stamp: 'mt 9/10/2010 10:35:54.919'!
executeUpdate: anUpdate

	PSCurrentRemoteClient
		value: nil
		during: [super executeUpdate: anUpdate].! !

!PSLocalClient methodsFor: 'snapshot handling' stamp: 'mt 9/10/2010 10:35:05.004'!
fileInSnapshot
	"Do not allow external snapshot updates for me. Defer the reaction because SqSync will not replicate the call otherwise."
	
	WorldState addDeferredUIMessage: [
		PSCurrentRemoteClient
			value: nil
			during: [self updateSnapshot]].! !

!PSLocalClient methodsFor: 'initialize' stamp: 'mt 9/8/2010 09:23:53.479'!
initialize
	
	super initialize.
	self enableNotificationProcessing.! !

!PSLocalClient methodsFor: 'testing' stamp: 'mt 9/8/2010 11:03:37.277'!
isConnected

	^ self connection notNil and: [self connection isConnected]! !

!PSLocalClient methodsFor: 'notifications' stamp: 'mt 9/10/2010 11:52:27.941'!
processNotification: anEvent
	"Filter according to the registered categories in the source code. Then add the update."
	
	| sourceCode sourceCodeClient |
	anEvent isDoIt ifTrue: [^ self].
	PSReplicateSystemEvents value ifNotNil: [^ self].
	
	"Just for debugging reasons: Output the current event."
	Transcript cr; show: anEvent itemKind asString, ' ', anEvent changeKind asString, ' ', anEvent itemCategory.
	
	"Get client and source code according to dynamic scope."
	sourceCodeClient := PSCurrentRemoteClient value ifNil: [self].
	sourceCode := sourceCodeClient sourceCode.
	sourceCode ifNil: [^ self].
	
	"Check if category is of interest."
	((anEvent itemKind = AbstractEvent categoryKind and: [sourceCode categories includes: anEvent itemCategory])
		or: [anEvent itemKind ~= AbstractEvent categoryKind and: [sourceCode categories includes: anEvent itemClass instanceSide category]])	
		ifFalse: [^ self].
	
	"Create the update object and add it to the model."
	sourceCode disconnectSignal: #updateAdded: from: sourceCodeClient.
	sourceCode addUpdate: (self class createUpdateFromEvent: anEvent).
	self connect: sourceCode signal: #updateAdded: to: sourceCodeClient selector: #executeUpdateSilently:.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/9/2010 09:51:20.918'!
remoteClientAdded: aRemoteClient

	self emit.! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/9/2010 09:51:27.22'!
remoteClientRemoved: aRemoteClient

	self emit.! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mig 9/8/2010 15:06:44.581'!
remoteClients

	^ remoteClients! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 09:57:30.035'!
remoteClients: someRemoteClients

	remoteClients := someRemoteClients.! !

!PSLocalClient methodsFor: 'remote client handling' stamp: 'mt 9/9/2010 09:59:26.665'!
removeRemoteClient: aSourceCode

	| oldRemoteClient |
	oldRemoteClient := self remoteClients detect: [:rc | rc sourceCode uuid = aSourceCode uuid] ifNone: [].
	self remoteClients remove: oldRemoteClient.
	self remoteClientRemoved: oldRemoteClient.
! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 09:57:09.281'!
repository

	^ self connection ifNotNil: [:c | c repository rootObject]! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 15:39:07.636'!
sourceCode

	| result |
	self repository ifNotNil: [:repo |
		"Due to lazy source code adding, we need to disconnect first."
		repo disconnectSignal: #sourceCodeAdded: from: self.
		result := repo sourceCodeByID: self uuid.
		self connect: repo signal: #sourceCodeAdded: toSelector: #addRemoteClient:].
	^ result! !

!PSLocalClient methodsFor: 'snapshot handling' stamp: 'mt 9/10/2010 10:36:20.997'!
updateSnapshot

	PSCurrentRemoteClient
		value: nil
		during: [super updateSnapshot].! !

!PSLocalClient methodsFor: 'accessing' stamp: 'mt 9/8/2010 10:57:15.36'!
uuid

	^ uuid ifNil: [
		uuid := UUID new.
		self uuidGenerated: uuid.
		uuid]! !

!PSLocalClient methodsFor: 'signals' stamp: 'mt 9/8/2010 10:56:59.263'!
uuidGenerated: aUUID

	self emit.! !

PSSourceCodeClient subclass: #PSRemoteClient
	instanceVariableNames: 'systemDictionary systemOrganization sourceCode systemEventActionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

!PSRemoteClient commentStamp: 'mt 9/8/2010 09:25:22.355' prior: 0!
I am kind of a view to the source code of a remote client. A morphic remote project uses me to define a dynamic scope to allow tools access to that source code.!

!PSRemoteClient methodsFor: 'update handling' stamp: 'mt 9/9/2010 12:07:31.099'!
executeUpdate: anUpdate

	Smalltalk globals isProxy ifFalse: [Error signal: 'Proxy needed!!'].

	PSCurrentRemoteClient
		value: self
		during: [super executeUpdate: anUpdate].! !

!PSRemoteClient methodsFor: 'snapshot handling' stamp: 'mt 9/9/2010 16:13:21.891'!
fileInSnapshot
	
	Smalltalk globals isProxy ifFalse: [Error signal: 'Proxy needed!!'].
	
	self resetSystemVariables.
	
	PSCurrentRemoteClient
		value: self
		during: [super fileInSnapshot].! !

!PSRemoteClient methodsFor: 'initialize' stamp: 'mt 9/9/2010 16:13:46.632'!
initialize

	super initialize.
	
	self resetSystemVariables.
	
	systemEventActionMap := (SystemChangeNotifier uniqueInstance instVarNamed: #eventSource) actionMap copy.! !

!PSRemoteClient methodsFor: 'as yet unclassified' stamp: 'mt 9/9/2010 12:07:18.98'!
loadSourceCode

	PSCurrentRemoteClient
		value: self
		during: [super loadSourceCode].! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/7/2010 13:11:20.034'!
name

	^ self sourceCode
		ifNil: [super name]
		ifNotNil: [self sourceCode uuid asString]! !

!PSRemoteClient methodsFor: 'open' stamp: 'mt 9/8/2010 11:53:28.991'!
open
	"Create a remote project and open a viewer for it."
	
	| project |
	project := PSRemoteProject new.
	project world remoteClient: self.
	ProjectViewMorph openOn: project.! !

!PSRemoteClient methodsFor: 'initialize' stamp: 'mt 9/9/2010 16:13:33.274'!
resetSystemVariables
	
	PSCurrentRemoteClient 
		value: nil
		during: [
			systemDictionary := PSSystemDictionary new.
			systemOrganization := SystemOrganization deepCopy].! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:34:12.155'!
sourceCode

	^ sourceCode! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 11:56:35.135'!
sourceCode: aSourceCode

	sourceCode ifNotNil: [
		sourceCode disconnectSignal: #updateAdded: from: self.
		sourceCode disconnectSignal: #snaptshotChanged: from: self].

	sourceCode := aSourceCode.
	
	sourceCode ifNotNil: [
		self loadSourceCode.
		self connect: sourceCode signal: #updateAdded: toSelector: #executeUpdateSilently:.
		self connect: sourceCode signal: #snapshotChanged: toSelector: #fileInSnapshot].! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:18:13.62'!
systemDictionary

	^ systemDictionary! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/9/2010 14:42:51.531'!
systemEventActionMap

	^ systemEventActionMap! !

!PSRemoteClient methodsFor: 'accessing' stamp: 'mt 9/6/2010 11:18:10.182'!
systemOrganization

	^ systemOrganization! !

!PSRemoteClient methodsFor: 'snapshot handling' stamp: 'mt 9/9/2010 10:00:20.26'!
updateSnapshot

	PSCurrentRemoteClient
		value: self
		during: [super updateSnapshot].! !

!PSSourceCodeClient class methodsFor: 'support' stamp: 'mt 9/9/2010 11:09:08.374'!
createUpdateFromEvent: anEvent

	| result env |
	result := anEvent copy.
	env := (anEvent instVarNamed: #environment) copy.

	"Use custom environment."
	result instVarNamed: #environment put: env.

	"Generic transformations."
	result itemClass ifNotNil: [result itemClass: result itemClass name asSymbol].
	result itemRequestor ifNotNil: [result itemRequestor: nil]. "Cannot transport requestor instance anyway."
	result itemMethod ifNotNil: [result itemMethod: result itemMethod selector].

	"Kind-Specific transformations."
	anEvent itemKind = AbstractEvent classKind ifTrue: [
		result instVarNamed: #item put: anEvent item name asSymbol. "class name by default"
		(anEvent isAdded or: [anEvent isModified])
			ifTrue: [result instVarNamed: #item put: anEvent item definition]. "class definition"
		anEvent isModified ifTrue: [result oldItem: anEvent oldItem name asSymbol]. "old class name"
		anEvent isCommented ifTrue: [result instVarNamed: #item put: anEvent item comment]. "class comment"
		anEvent isReorganized ifTrue: [
			result instVarNamed: #item put: anEvent item organization asString]. "class protocols"].
		
	anEvent itemKind = AbstractEvent methodKind ifTrue: [
		result instVarNamed: #item put: anEvent item selector. "method selector by default"
		(anEvent isAdded or: [anEvent isModified]) ifTrue: [
			result instVarNamed: #item put: (self fileOutSourceFor: anEvent item)]. "method source" 
		anEvent isModified ifTrue: [result oldItem: anEvent oldItem selector]. "old selector"].
	
	^ PSSourceCodeUpdate new event: result! !

!PSSourceCodeClient class methodsFor: 'support' stamp: 'mt 9/9/2010 10:05:34.608'!
fileOutSourceFor: aCompiledMethod
	"Better than just #getSource. Preserves Protocols."
	
	| strm |
	strm := WriteStream on: (String new: 1000).

	strm header; timeStamp.
	aCompiledMethod methodClass
		printMethodChunk: aCompiledMethod selector
		withPreamble: true
		on: strm
		moveSource: false
		toFile: 0.
		
	^ strm contents! !

!PSSourceCodeClient methodsFor: 'update handling' stamp: 'mt 9/9/2010 16:04:14.61'!
executeUpdate: anUpdate

	| event |
	event := anUpdate event.
	
	event itemKind = AbstractEvent categoryKind ifTrue: [
		event isAdded ifTrue: [SystemOrganization addCategory: event item].
		"event isModified ?"
		event isRemoved ifTrue: [SystemOrganization removeSystemCategory: event item].
		event isRenamed ifTrue: [SystemOrganization renameCategory: event oldName toBe: event newName]].
	
	event itemKind = AbstractEvent classKind ifTrue: [
		event isAdded ifTrue: [Compiler evaluate: event item "class definition"].
		event isCommented ifTrue: [(Smalltalk at: anUpdate eventItemClass) comment: event item "class comment"].
		event isModified ifTrue: [Compiler evaluate: event item "modified class definition"].
		event isRecategorized ifTrue: [(Smalltalk at: anUpdate eventItemClass) category: event itemCategory].
		event isRemoved ifTrue: [(Smalltalk at: anUpdate eventItemClass) removeFromSystem].
		event isRenamed ifTrue: [(Smalltalk at: event oldName) rename: event newName].
		event isReorganized ifTrue: [(Smalltalk at: anUpdate eventItemClass) organization changeFromString: event item "class protocols"]].
	
	event itemKind = AbstractEvent methodKind ifTrue: [
		(event isAdded or: [event isModified]) ifTrue: [(ReadStream on: event item) fileIn "method fileOut source with timeStamps and protocols a.s.o."].
		event isRecategorized ifTrue: [(Smalltalk at: anUpdate eventItemClass) organization classify: event item under: event itemProtocol].
		event isRemoved ifTrue: [(Smalltalk at: anUpdate eventItemClass) removeSelector: event item]].! !

!PSSourceCodeClient methodsFor: 'update handling' stamp: 'mt 9/9/2010 11:00:23.765'!
executeUpdateSilently: anUpdate

	PSReplicateSystemEvents
		value: false
		during: [self executeUpdate: anUpdate].! !

!PSSourceCodeClient methodsFor: 'snapshot handling' stamp: 'mt 9/9/2010 12:00:42.815'!
fileInSnapshot
	"Load the source of all categories in the current snapshot into the image."
	
	self sourceCode snapshot ifNil: [^ self].
	self sourceCode snapshot keysAndValuesDo: [:category :source | | strm |
		(ReadStream on: source) fileIn].! !

!PSSourceCodeClient methodsFor: 'as yet unclassified' stamp: 'mt 9/10/2010 10:34:10.498'!
loadSourceCode
	"Read the complete snapshot and all updates."
	
	PSReplicateSystemEvents
		value: false "Do it silently."
		during: [
			self fileInSnapshot.
			self sourceCode updates do: [:update | self executeUpdateSilently: update]].! !

!PSSourceCodeClient methodsFor: 'update handling' stamp: 'mt 9/8/2010 09:11:57.091'!
sourceCode

	self subclassResponsibility.! !

!PSSourceCodeClient methodsFor: 'snapshot handling' stamp: 'mt 9/10/2010 11:00:05.203'!
updateSnapshot
	"Extract the source code of all registered categories into a dictionary."
	
	| updatedSnapshot |
	updatedSnapshot := Dictionary new.
	
	self sourceCode packages do: [:pkg |
		(PackageInfo named: pkg) systemCategories do: [:cat | | strm |
			strm := WriteStream on: (String new: 100).
			SystemOrganization fileOutCategory: cat on: strm.
			updatedSnapshot at: cat put: strm contents]].
	
	self sourceCode disconnectSignal: #snapshotChanged: from: self.
	self sourceCode snapshot: updatedSnapshot.
	self connect: self sourceCode signal: #snapshotChanged: toSelector: #fileInSnapshot.! !

!SystemOrganizer methodsFor: '*polysource-core' stamp: 'mt 8/30/2010 11:30:34.255'!
isProxy

	^ false! !

UserInterface subclass: #PSControlPanelUi
	instanceVariableNames: 'morphy1 serverContainer serverLabel morphy2 hostNameEdit portEdit morphy3 morphy4 connectButton remoteContainer remoteLabel remoteList morphy5 morphy6 openProjectButton localContainer localLabel morphy7 categoryList morphy8 morphy9 addCategoryButton removeCategoryButton uuidLabel morphy10 resetButton morphy11 updateButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Dialogs'!

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.952'!
addCategoryButton
	"No description given."
	
	^ addCategoryButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.802'!
categoryList
	"No description given."
	
	^ categoryList! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.258'!
connectButton
	"No description given."
	
	^ connectButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.051'!
hostNameEdit
	"No description given."
	
	^ hostNameEdit! !

!PSControlPanelUi methodsFor: 'ui - private' stamp: 'mt 9/10/2010 11:40:59.34'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: 426@540.
	panel position: 776@367.
	panel hResizing: #spaceFill.
	panel vResizing: #spaceFill.
	panel cellInset: 10.
	panel cellPositioning: #center.
	panel cellSpacing: #none.
	panel layoutInset: 0.
	panel listCentering: #topLeft.
	panel listDirection: #leftToRight.
	panel listSpacing: #none.
	panel maxCellSize: 1073741823.
	panel minCellSize: 0.
	panel wrapCentering: #topLeft.
	panel wrapDirection: #none.
	panel setProperty: #objectName toValue: 'panel'.
	panel setProperty: #objectDescription toValue: ''.
	morphy1 := UiContainer new.
	morphy1 changeTableLayout.
	morphy1 extent: 164@540.
	morphy1 position: 776@367.
	morphy1 hResizing: #spaceFill.
	morphy1 vResizing: #spaceFill.
	morphy1 cellInset: 10.
	morphy1 cellPositioning: #center.
	morphy1 cellSpacing: #none.
	morphy1 layoutInset: 0.
	morphy1 listCentering: #topLeft.
	morphy1 listDirection: #topToBottom.
	morphy1 listSpacing: #none.
	morphy1 maxCellSize: 1073741823.
	morphy1 minCellSize: 0.
	morphy1 wrapCentering: #topLeft.
	morphy1 wrapDirection: #none.
	morphy1 setProperty: #objectName toValue: 'morphy1'.
	morphy1 setProperty: #objectDescription toValue: 'No description given.'.
	serverContainer := UiContainer new.
	serverContainer changeTableLayout.
	serverContainer extent: 164@92.
	serverContainer position: 776@366.
	serverContainer hResizing: #spaceFill.
	serverContainer vResizing: #shrinkWrap.
	serverContainer cellInset: 5.
	serverContainer cellPositioning: #topLeft.
	serverContainer cellSpacing: #none.
	serverContainer layoutInset: 5.
	serverContainer listCentering: #topLeft.
	serverContainer listDirection: #topToBottom.
	serverContainer listSpacing: #none.
	serverContainer maxCellSize: 1073741823.
	serverContainer minCellSize: 0.
	serverContainer wrapCentering: #topLeft.
	serverContainer wrapDirection: #none.
	serverContainer setProperty: #objectName toValue: 'serverContainer'.
	serverContainer setProperty: #objectDescription toValue: 'No description given.'.
	serverLabel := UiLabel new.
	serverLabel changeTableLayout.
	serverLabel extent: 41@18.
	serverLabel position: 781@371.
	serverLabel hResizing: #shrinkWrap.
	serverLabel vResizing: #shrinkWrap.
	serverLabel cellInset: 0.
	serverLabel cellPositioning: #center.
	serverLabel cellSpacing: #none.
	serverLabel layoutInset: 0.
	serverLabel listCentering: #topLeft.
	serverLabel listDirection: #leftToRight.
	serverLabel listSpacing: #none.
	serverLabel maxCellSize: 1073741823.
	serverLabel minCellSize: 0.
	serverLabel wrapCentering: #topLeft.
	serverLabel wrapDirection: #none.
	serverLabel text: 'Server'.
	serverLabel setProperty: #objectName toValue: 'serverLabel'.
	serverLabel setProperty: #objectDescription toValue: 'No description given.'.
	serverContainer addMorphBack: serverLabel.
	morphy2 := UiContainer new.
	morphy2 changeTableLayout.
	morphy2 extent: 154@22.
	morphy2 position: 781@394.
	morphy2 hResizing: #spaceFill.
	morphy2 vResizing: #shrinkWrap.
	morphy2 cellInset: 4.
	morphy2 cellPositioning: #center.
	morphy2 cellSpacing: #none.
	morphy2 layoutInset: 0.
	morphy2 listCentering: #topLeft.
	morphy2 listDirection: #leftToRight.
	morphy2 listSpacing: #none.
	morphy2 maxCellSize: 1073741823.
	morphy2 minCellSize: 0.
	morphy2 wrapCentering: #topLeft.
	morphy2 wrapDirection: #none.
	morphy2 setProperty: #objectName toValue: 'morphy2'.
	morphy2 setProperty: #objectDescription toValue: 'No description given.'.
	hostNameEdit := UiLineEdit new.
	hostNameEdit extent: 78@20.
	hostNameEdit position: 781@395.
	hostNameEdit hResizing: #spaceFill.
	hostNameEdit vResizing: #rigid.
	hostNameEdit cellInset: 0.
	hostNameEdit cellPositioning: #center.
	hostNameEdit cellSpacing: #none.
	hostNameEdit layoutInset: 0.
	hostNameEdit listCentering: #topLeft.
	hostNameEdit listDirection: #topToBottom.
	hostNameEdit listSpacing: #none.
	hostNameEdit maxCellSize: 1073741823.
	hostNameEdit minCellSize: 0.
	hostNameEdit wrapCentering: #topLeft.
	hostNameEdit wrapDirection: #none.
	hostNameEdit setProperty: #objectName toValue: 'hostNameEdit'.
	hostNameEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy2 addMorphBack: hostNameEdit.
	portEdit := UiLineEdit new.
	portEdit extent: 70@20.
	portEdit position: 863@394.
	portEdit hResizing: #rigid.
	portEdit vResizing: #rigid.
	portEdit cellInset: 0.
	portEdit cellPositioning: #center.
	portEdit cellSpacing: #none.
	portEdit layoutInset: 0.
	portEdit listCentering: #topLeft.
	portEdit listDirection: #topToBottom.
	portEdit listSpacing: #none.
	portEdit maxCellSize: 1073741823.
	portEdit minCellSize: 0.
	portEdit wrapCentering: #topLeft.
	portEdit wrapDirection: #none.
	portEdit setProperty: #objectName toValue: 'portEdit'.
	portEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy2 addMorphBack: portEdit.
	serverContainer addMorphBack: morphy2.
	morphy3 := UiContainer new.
	morphy3 changeTableLayout.
	morphy3 extent: 154@29.
	morphy3 position: 781@421.
	morphy3 hResizing: #spaceFill.
	morphy3 vResizing: #shrinkWrap.
	morphy3 cellInset: 4.
	morphy3 cellPositioning: #center.
	morphy3 cellSpacing: #none.
	morphy3 layoutInset: 0.
	morphy3 listCentering: #topLeft.
	morphy3 listDirection: #leftToRight.
	morphy3 listSpacing: #none.
	morphy3 maxCellSize: 1073741823.
	morphy3 minCellSize: 0.
	morphy3 wrapCentering: #topLeft.
	morphy3 wrapDirection: #none.
	morphy3 setProperty: #objectName toValue: 'morphy3'.
	morphy3 setProperty: #objectDescription toValue: 'No description given.'.
	morphy4 := UiContainer new.
	morphy4 extent: 67@10.
	morphy4 position: 781@431.
	morphy4 hResizing: #spaceFill.
	morphy4 vResizing: #rigid.
	morphy4 cellInset: 4.
	morphy4 cellPositioning: #center.
	morphy4 cellSpacing: #none.
	morphy4 layoutInset: 4.
	morphy4 listCentering: #topLeft.
	morphy4 listDirection: #topToBottom.
	morphy4 listSpacing: #none.
	morphy4 maxCellSize: 1073741823.
	morphy4 minCellSize: 0.
	morphy4 wrapCentering: #topLeft.
	morphy4 wrapDirection: #none.
	morphy4 setProperty: #objectName toValue: 'morphy4'.
	morphy4 setProperty: #objectDescription toValue: 'No description given.'.
	morphy3 addMorphBack: morphy4.
	connectButton := UiPushButton new.
	connectButton changeTableLayout.
	connectButton extent: 81@28.
	connectButton position: 852@421.
	connectButton hResizing: #shrinkWrap.
	connectButton vResizing: #shrinkWrap.
	connectButton cellInset: 4.
	connectButton cellPositioning: #center.
	connectButton cellSpacing: #none.
	connectButton layoutInset: 4.
	connectButton listCentering: #topLeft.
	connectButton listDirection: #leftToRight.
	connectButton listSpacing: #none.
	connectButton maxCellSize: 1073741823.
	connectButton minCellSize: 0.
	connectButton wrapCentering: #topLeft.
	connectButton wrapDirection: #none.
	connectButton text: 'Connect'.
	connectButton setProperty: #objectName toValue: 'connectButton'.
	connectButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy3 addMorphBack: connectButton.
	serverContainer addMorphBack: morphy3.
	morphy1 addMorphBack: serverContainer.
	remoteContainer := UiContainer new.
	remoteContainer changeTableLayout.
	remoteContainer extent: 164@440.
	remoteContainer position: 776@467.
	remoteContainer hResizing: #spaceFill.
	remoteContainer vResizing: #spaceFill.
	remoteContainer cellInset: 4.
	remoteContainer cellPositioning: #topLeft.
	remoteContainer cellSpacing: #none.
	remoteContainer layoutInset: 4.
	remoteContainer listCentering: #topLeft.
	remoteContainer listDirection: #topToBottom.
	remoteContainer listSpacing: #none.
	remoteContainer maxCellSize: 1073741823.
	remoteContainer minCellSize: 0.
	remoteContainer wrapCentering: #topLeft.
	remoteContainer wrapDirection: #none.
	remoteContainer setProperty: #objectName toValue: 'remoteContainer'.
	remoteContainer setProperty: #objectDescription toValue: 'No description given.'.
	remoteLabel := UiLabel new.
	remoteLabel changeTableLayout.
	remoteLabel extent: 138@18.
	remoteLabel position: 780@471.
	remoteLabel hResizing: #shrinkWrap.
	remoteLabel vResizing: #shrinkWrap.
	remoteLabel cellInset: 0.
	remoteLabel cellPositioning: #center.
	remoteLabel cellSpacing: #none.
	remoteLabel layoutInset: 0.
	remoteLabel listCentering: #topLeft.
	remoteLabel listDirection: #leftToRight.
	remoteLabel listSpacing: #none.
	remoteLabel maxCellSize: 1073741823.
	remoteLabel minCellSize: 0.
	remoteLabel wrapCentering: #topLeft.
	remoteLabel wrapDirection: #none.
	remoteLabel text: 'Remote Source Codes'.
	remoteLabel setProperty: #objectName toValue: 'remoteLabel'.
	remoteLabel setProperty: #objectDescription toValue: 'No description given.'.
	remoteContainer addMorphBack: remoteLabel.
	remoteList := UiListWidget new.
	remoteList extent: 156@376.
	remoteList position: 780@493.
	remoteList hResizing: #spaceFill.
	remoteList vResizing: #spaceFill.
	remoteList cellInset: 0.
	remoteList cellPositioning: #center.
	remoteList cellSpacing: #none.
	remoteList layoutInset: 0.
	remoteList listCentering: #topLeft.
	remoteList listDirection: #topToBottom.
	remoteList listSpacing: #none.
	remoteList maxCellSize: 1073741823.
	remoteList minCellSize: 0.
	remoteList wrapCentering: #topLeft.
	remoteList wrapDirection: #none.
	remoteList setProperty: #objectName toValue: 'remoteList'.
	remoteList setProperty: #objectDescription toValue: 'No description given.'.
	remoteContainer addMorphBack: remoteList.
	morphy5 := UiContainer new.
	morphy5 changeTableLayout.
	morphy5 extent: 156@29.
	morphy5 position: 780@873.
	morphy5 hResizing: #spaceFill.
	morphy5 vResizing: #shrinkWrap.
	morphy5 cellInset: 4.
	morphy5 cellPositioning: #center.
	morphy5 cellSpacing: #none.
	morphy5 layoutInset: 0.
	morphy5 listCentering: #topLeft.
	morphy5 listDirection: #leftToRight.
	morphy5 listSpacing: #none.
	morphy5 maxCellSize: 1073741823.
	morphy5 minCellSize: 0.
	morphy5 wrapCentering: #topLeft.
	morphy5 wrapDirection: #none.
	morphy5 setProperty: #objectName toValue: 'morphy5'.
	morphy5 setProperty: #objectDescription toValue: 'No description given.'.
	morphy6 := UiContainer new.
	morphy6 extent: 39@10.
	morphy6 position: 780@883.
	morphy6 hResizing: #spaceFill.
	morphy6 vResizing: #rigid.
	morphy6 cellInset: 4.
	morphy6 cellPositioning: #center.
	morphy6 cellSpacing: #none.
	morphy6 layoutInset: 4.
	morphy6 listCentering: #topLeft.
	morphy6 listDirection: #topToBottom.
	morphy6 listSpacing: #none.
	morphy6 maxCellSize: 1073741823.
	morphy6 minCellSize: 0.
	morphy6 wrapCentering: #topLeft.
	morphy6 wrapDirection: #none.
	morphy6 setProperty: #objectName toValue: 'morphy6'.
	morphy6 setProperty: #objectDescription toValue: 'No description given.'.
	morphy5 addMorphBack: morphy6.
	openProjectButton := UiPushButton new.
	openProjectButton changeTableLayout.
	openProjectButton extent: 111@28.
	openProjectButton position: 823@873.
	openProjectButton hResizing: #shrinkWrap.
	openProjectButton vResizing: #shrinkWrap.
	openProjectButton cellInset: 4.
	openProjectButton cellPositioning: #center.
	openProjectButton cellSpacing: #none.
	openProjectButton layoutInset: 4.
	openProjectButton listCentering: #topLeft.
	openProjectButton listDirection: #leftToRight.
	openProjectButton listSpacing: #none.
	openProjectButton maxCellSize: 1073741823.
	openProjectButton minCellSize: 0.
	openProjectButton wrapCentering: #topLeft.
	openProjectButton wrapDirection: #none.
	openProjectButton text: 'Open Project'.
	openProjectButton setProperty: #objectName toValue: 'openProjectButton'.
	openProjectButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy5 addMorphBack: openProjectButton.
	remoteContainer addMorphBack: morphy5.
	morphy1 addMorphBack: remoteContainer.
	panel addMorphBack: morphy1.
	localContainer := UiContainer new.
	localContainer changeTableLayout.
	localContainer extent: 252@540.
	localContainer position: 950@367.
	localContainer hResizing: #spaceFill.
	localContainer vResizing: #spaceFill.
	localContainer cellInset: 5.
	localContainer cellPositioning: #topLeft.
	localContainer cellSpacing: #none.
	localContainer layoutInset: 5.
	localContainer listCentering: #topLeft.
	localContainer listDirection: #topToBottom.
	localContainer listSpacing: #none.
	localContainer maxCellSize: 1073741823.
	localContainer minCellSize: 0.
	localContainer wrapCentering: #topLeft.
	localContainer wrapDirection: #none.
	localContainer setProperty: #objectName toValue: 'localContainer'.
	localContainer setProperty: #objectDescription toValue: 'No description given.'.
	localLabel := UiLabel new.
	localLabel changeTableLayout.
	localLabel extent: 101@18.
	localLabel position: 955@372.
	localLabel hResizing: #shrinkWrap.
	localLabel vResizing: #shrinkWrap.
	localLabel cellInset: 0.
	localLabel cellPositioning: #center.
	localLabel cellSpacing: #none.
	localLabel layoutInset: 0.
	localLabel listCentering: #topLeft.
	localLabel listDirection: #leftToRight.
	localLabel listSpacing: #none.
	localLabel maxCellSize: 1073741823.
	localLabel minCellSize: 0.
	localLabel wrapCentering: #topLeft.
	localLabel wrapDirection: #none.
	localLabel text: 'My Source Code'.
	localLabel setProperty: #objectName toValue: 'localLabel'.
	localLabel setProperty: #objectDescription toValue: 'No description given.'.
	localContainer addMorphBack: localLabel.
	morphy7 := UiContainer new.
	morphy7 changeTableLayout.
	morphy7 extent: 242@447.
	morphy7 position: 955@395.
	morphy7 hResizing: #spaceFill.
	morphy7 vResizing: #spaceFill.
	morphy7 cellInset: 0.
	morphy7 cellPositioning: #center.
	morphy7 cellSpacing: #none.
	morphy7 layoutInset: 0.
	morphy7 listCentering: #topLeft.
	morphy7 listDirection: #leftToRight.
	morphy7 listSpacing: #none.
	morphy7 maxCellSize: 1073741823.
	morphy7 minCellSize: 0.
	morphy7 wrapCentering: #topLeft.
	morphy7 wrapDirection: #none.
	morphy7 setProperty: #objectName toValue: 'morphy7'.
	morphy7 setProperty: #objectDescription toValue: 'No description given.'.
	categoryList := UiListWidget new.
	categoryList extent: 203@447.
	categoryList position: 955@395.
	categoryList hResizing: #spaceFill.
	categoryList vResizing: #spaceFill.
	categoryList cellInset: 0.
	categoryList cellPositioning: #center.
	categoryList cellSpacing: #none.
	categoryList layoutInset: 0.
	categoryList listCentering: #topLeft.
	categoryList listDirection: #topToBottom.
	categoryList listSpacing: #none.
	categoryList maxCellSize: 1073741823.
	categoryList minCellSize: 0.
	categoryList wrapCentering: #topLeft.
	categoryList wrapDirection: #none.
	categoryList setProperty: #objectName toValue: 'categoryList'.
	categoryList setProperty: #objectDescription toValue: 'No description given.'.
	morphy7 addMorphBack: categoryList.
	morphy8 := UiContainer new.
	morphy8 changeTableLayout.
	morphy8 extent: 39@447.
	morphy8 position: 1158@395.
	morphy8 hResizing: #shrinkWrap.
	morphy8 vResizing: #spaceFill.
	morphy8 cellInset: 0.
	morphy8 cellPositioning: #center.
	morphy8 cellSpacing: #none.
	morphy8 layoutInset: 0.
	morphy8 listCentering: #topLeft.
	morphy8 listDirection: #topToBottom.
	morphy8 listSpacing: #none.
	morphy8 maxCellSize: 1073741823.
	morphy8 minCellSize: 0.
	morphy8 wrapCentering: #topLeft.
	morphy8 wrapDirection: #none.
	morphy8 setProperty: #objectName toValue: 'morphy8'.
	morphy8 setProperty: #objectDescription toValue: 'No description given.'.
	morphy9 := UiContainer new.
	morphy9 extent: 10@391.
	morphy9 position: 1172@395.
	morphy9 hResizing: #rigid.
	morphy9 vResizing: #spaceFill.
	morphy9 cellInset: 4.
	morphy9 cellPositioning: #center.
	morphy9 cellSpacing: #none.
	morphy9 layoutInset: 4.
	morphy9 listCentering: #topLeft.
	morphy9 listDirection: #topToBottom.
	morphy9 listSpacing: #none.
	morphy9 maxCellSize: 1073741823.
	morphy9 minCellSize: 0.
	morphy9 wrapCentering: #topLeft.
	morphy9 wrapDirection: #none.
	morphy9 setProperty: #objectName toValue: 'morphy9'.
	morphy9 setProperty: #objectDescription toValue: 'No description given.'.
	morphy8 addMorphBack: morphy9.
	addCategoryButton := UiToolButton new.
	addCategoryButton changeTableLayout.
	addCategoryButton extent: 39@28.
	addCategoryButton position: 1158@786.
	addCategoryButton hResizing: #shrinkWrap.
	addCategoryButton vResizing: #shrinkWrap.
	addCategoryButton cellInset: 4.
	addCategoryButton cellPositioning: #center.
	addCategoryButton cellSpacing: #none.
	addCategoryButton layoutInset: 4.
	addCategoryButton listCentering: #topLeft.
	addCategoryButton listDirection: #leftToRight.
	addCategoryButton listSpacing: #none.
	addCategoryButton maxCellSize: 1073741823.
	addCategoryButton minCellSize: 0.
	addCategoryButton wrapCentering: #topLeft.
	addCategoryButton wrapDirection: #none.
	addCategoryButton text: '+'.
	addCategoryButton setProperty: #objectName toValue: 'addCategoryButton'.
	addCategoryButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy8 addMorphBack: addCategoryButton.
	removeCategoryButton := UiToolButton new.
	removeCategoryButton changeTableLayout.
	removeCategoryButton extent: 39@28.
	removeCategoryButton position: 1158@814.
	removeCategoryButton hResizing: #shrinkWrap.
	removeCategoryButton vResizing: #shrinkWrap.
	removeCategoryButton cellInset: 4.
	removeCategoryButton cellPositioning: #center.
	removeCategoryButton cellSpacing: #none.
	removeCategoryButton layoutInset: 4.
	removeCategoryButton listCentering: #topLeft.
	removeCategoryButton listDirection: #leftToRight.
	removeCategoryButton listSpacing: #none.
	removeCategoryButton maxCellSize: 1073741823.
	removeCategoryButton minCellSize: 0.
	removeCategoryButton wrapCentering: #topLeft.
	removeCategoryButton wrapDirection: #none.
	removeCategoryButton text: '-'.
	removeCategoryButton setProperty: #objectName toValue: 'removeCategoryButton'.
	removeCategoryButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy8 addMorphBack: removeCategoryButton.
	morphy7 addMorphBack: morphy8.
	localContainer addMorphBack: morphy7.
	uuidLabel := UiLabel new.
	uuidLabel changeTableLayout.
	uuidLabel extent: 38@18.
	uuidLabel position: 955@847.
	uuidLabel hResizing: #shrinkWrap.
	uuidLabel vResizing: #shrinkWrap.
	uuidLabel cellInset: 0.
	uuidLabel cellPositioning: #center.
	uuidLabel cellSpacing: #none.
	uuidLabel layoutInset: 0.
	uuidLabel listCentering: #topLeft.
	uuidLabel listDirection: #leftToRight.
	uuidLabel listSpacing: #none.
	uuidLabel maxCellSize: 1073741823.
	uuidLabel minCellSize: 0.
	uuidLabel wrapCentering: #topLeft.
	uuidLabel wrapDirection: #none.
	uuidLabel text: '(UUID)'.
	uuidLabel setProperty: #objectName toValue: 'uuidLabel'.
	uuidLabel setProperty: #objectDescription toValue: 'No description given.'.
	localContainer addMorphBack: uuidLabel.
	morphy10 := UiContainer new.
	morphy10 changeTableLayout.
	morphy10 extent: 242@31.
	morphy10 position: 955@870.
	morphy10 hResizing: #spaceFill.
	morphy10 vResizing: #shrinkWrap.
	morphy10 cellInset: 4.
	morphy10 cellPositioning: #center.
	morphy10 cellSpacing: #none.
	morphy10 layoutInset: 0.
	morphy10 listCentering: #topLeft.
	morphy10 listDirection: #leftToRight.
	morphy10 listSpacing: #none.
	morphy10 maxCellSize: 1073741823.
	morphy10 minCellSize: 0.
	morphy10 wrapCentering: #topLeft.
	morphy10 wrapDirection: #none.
	morphy10 setProperty: #objectName toValue: 'morphy10'.
	morphy10 setProperty: #objectDescription toValue: 'No description given.'.
	resetButton := UiPushButton new.
	resetButton changeTableLayout.
	resetButton extent: 65@28.
	resetButton position: 956@872.
	resetButton hResizing: #shrinkWrap.
	resetButton vResizing: #shrinkWrap.
	resetButton cellInset: 4.
	resetButton cellPositioning: #center.
	resetButton cellSpacing: #none.
	resetButton layoutInset: 4.
	resetButton listCentering: #topLeft.
	resetButton listDirection: #leftToRight.
	resetButton listSpacing: #none.
	resetButton maxCellSize: 1073741823.
	resetButton minCellSize: 0.
	resetButton wrapCentering: #topLeft.
	resetButton wrapDirection: #none.
	resetButton text: 'Reset'.
	resetButton setProperty: #objectName toValue: 'resetButton'.
	resetButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy10 addMorphBack: resetButton.
	morphy11 := UiContainer new.
	morphy11 extent: 27@10.
	morphy11 position: 1026@881.
	morphy11 hResizing: #spaceFill.
	morphy11 vResizing: #rigid.
	morphy11 cellInset: 4.
	morphy11 cellPositioning: #center.
	morphy11 cellSpacing: #none.
	morphy11 layoutInset: 4.
	morphy11 listCentering: #topLeft.
	morphy11 listDirection: #topToBottom.
	morphy11 listSpacing: #none.
	morphy11 maxCellSize: 1073741823.
	morphy11 minCellSize: 0.
	morphy11 wrapCentering: #topLeft.
	morphy11 wrapDirection: #none.
	morphy11 setProperty: #objectName toValue: 'morphy11'.
	morphy11 setProperty: #objectDescription toValue: 'No description given.'.
	morphy10 addMorphBack: morphy11.
	updateButton := UiPushButton new.
	updateButton changeTableLayout.
	updateButton extent: 138@30.
	updateButton position: 1057@870.
	updateButton hResizing: #shrinkWrap.
	updateButton vResizing: #shrinkWrap.
	updateButton cellInset: 4.
	updateButton cellPositioning: #center.
	updateButton cellSpacing: #none.
	updateButton layoutInset: 4.
	updateButton listCentering: #topLeft.
	updateButton listDirection: #leftToRight.
	updateButton listSpacing: #none.
	updateButton maxCellSize: 1073741823.
	updateButton minCellSize: 0.
	updateButton wrapCentering: #topLeft.
	updateButton wrapDirection: #none.
	updateButton text: 'Update Snapshot'.
	updateButton setProperty: #objectName toValue: 'updateButton'.
	updateButton setProperty: #objectDescription toValue: 'No description given.'.
	morphy10 addMorphBack: updateButton.
	localContainer addMorphBack: morphy10.
	panel addMorphBack: localContainer.
	panel setProperty: #uiClassName toValue: 'PSControlPanel'.! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.655'!
localContainer
	"No description given."
	
	^ localContainer! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.708'!
localLabel
	"No description given."
	
	^ localLabel! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:57.833'!
morphy1
	"No description given."
	
	^ morphy1! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.088'!
morphy10
	"No description given."
	
	^ morphy10! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.19'!
morphy11
	"No description given."
	
	^ morphy11! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.002'!
morphy2
	"No description given."
	
	^ morphy2! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.169'!
morphy3
	"No description given."
	
	^ morphy3! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.218'!
morphy4
	"No description given."
	
	^ morphy4! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.507'!
morphy5
	"No description given."
	
	^ morphy5! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.544'!
morphy6
	"No description given."
	
	^ morphy6! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.743'!
morphy7
	"No description given."
	
	^ morphy7! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.843'!
morphy8
	"No description given."
	
	^ morphy8! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.887'!
morphy9
	"No description given."
	
	^ morphy9! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.601'!
openProjectButton
	"No description given."
	
	^ openProjectButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.111'!
portEdit
	"No description given."
	
	^ portEdit! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.319'!
remoteContainer
	"No description given."
	
	^ remoteContainer! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.396'!
remoteLabel
	"No description given."
	
	^ remoteLabel! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:58.454'!
remoteList
	"No description given."
	
	^ remoteList! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.008'!
removeCategoryButton
	"No description given."
	
	^ removeCategoryButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.123'!
resetButton
	"No description given."
	
	^ resetButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:57.904'!
serverContainer
	"No description given."
	
	^ serverContainer! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:57.95'!
serverLabel
	"No description given."
	
	^ serverLabel! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.238'!
updateButton
	"No description given."
	
	^ updateButton! !

!PSControlPanelUi methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:40:59.043'!
uuidLabel
	"No description given."
	
	^ uuidLabel! !

Morph subclass: #PSControlPanel
	instanceVariableNames: 'ui'
	classVariableNames: 'LastHostName LastPort'
	poolDictionaries: ''
	category: 'PolySource-Dialogs'!

!PSControlPanel class methodsFor: 'as yet unclassified' stamp: 'mt 9/8/2010 10:48:54.718'!
open

	self new open.! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/10/2010 11:39:40.102'!
addPackage

	| result |
	result := ListChooser
		chooseItemFrom: PackageOrganizer default packageNames sorted
		title: 'Select Package'.
	
	result ifNil: [^ self].
	
	PSLocalClient instance sourceCode addPackage: result.
	PSLocalClient instance updateSnapshot.! !

!PSControlPanel methodsFor: 'updating - category list' stamp: 'mt 9/10/2010 11:31:18.196'!
addPackage: aPackageName

	self ui categoryList addText: aPackageName.! !

!PSControlPanel methodsFor: 'updating - remote list' stamp: 'mt 9/9/2010 09:53:50.389'!
addRemoteClient: aRemoteClient

	self ui remoteList addText: aRemoteClient sourceCode uuid asString.! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 12:03:17.475'!
changeLastHostName: aText

	LastHostName := aText.! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 12:03:27.492'!
changeLastPort: aText

	LastPort := aText.! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/8/2010 11:12:09.606'!
connectToServer

	PSLocalClient instance connectTo: self ui hostNameEdit theText.! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/8/2010 11:12:19.039'!
disconnectFromServer

	PSLocalClient instance disconnect.! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/8/2010 11:35:00.001'!
initialize

	super initialize.
	self ui setupUi: self.
	self postUiSetup.
	
	self
		color: (Color gray: 0.8);
		width: 500;
		height: 350.
		
	self
		initializeConnections;
		updateServerInfo;
		updateUuidLabel: PSLocalClient instance uuid;
		updateRemoteInfo;
		updateLocalInfo.! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/10/2010 11:44:17.189'!
initializeConnections

	self connect: PSLocalClient instance signal: #connected toSelector: #updateServerInfo.
	self connect: PSLocalClient instance signal: #connected toSelector: #updateRemoteInfo.
	self connect: PSLocalClient instance signal: #connected toSelector: #updateLocalInfo.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateServerInfo.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateRemoteInfo.
	self connect: PSLocalClient instance signal: #disconnected toSelector: #updateLocalInfo.
	
	self connect: self ui resetButton signal: #clicked: to: PSLocalClient selector: #reset.
	self connect: self ui updateButton signal: #clicked: to: PSLocalClient instance selector: #updateSnapshot.

	self connect: self ui openProjectButton signal: #clicked: toSelector: #openRemoteProject.

	self connect: PSLocalClient instance signal: #uuidGenerated: toSelector: #updateUuidLabel:.
	
	self connect: self ui hostNameEdit signal: #textEdited: toSelector: #changeLastHostName:.
	self connect: self ui portEdit signal: #textEdited: toSelector: #changeLastPort:.! !

!PSControlPanel methodsFor: 'open' stamp: 'mt 9/9/2010 11:58:46.753'!
open

	| window |
	Smalltalk globals isProxy ifFalse: [Error signal: 'You need to install the proxy with: ''PSSystemDictionaryProxy install''.'].
	
	window := (self openInWindowLabeled: 'PolySource Control Panel')
		model: self.
		
	self color: (Color gray: 0.8).
	^ window! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/8/2010 12:09:00.391'!
openRemoteProject
	
	self ui remoteList currentItem ifNotNil: [:item |
		(PSLocalClient instance remoteClients
			detect: [:rc | rc sourceCode uuid asString = item text]
			ifNone: []) open].! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/10/2010 11:42:44.183'!
postUiSetup

	self ui remoteList autoDeselect: false.
	self ui categoryList autoDeselect: false.
	
	self ui serverLabel text: '<b>Server</b>' asHtmlText.
"	self ui serverContainer color: (Color gray: 0.7)."
	self ui remoteLabel text: '<b>Remote Source Codes</b>' asHtmlText.
"	self ui remoteContainer color: (Color gray: 0.7)."
	self ui localLabel text: '<b>My Source Code</b>' asHtmlText.
"	self ui localContainer color: (Color gray: 0.7)."
	
	self ui connectButton icon: UiSilkIcons connectIcon.
	self ui hostNameEdit theText: (LastHostName ifNil: ['localhost']).
	(self ui portEdit)
		theText: (LastPort ifNil: ['22701']);
		validator: [:value | value asInteger min: 65536 max: 0].
		
	self ui openProjectButton icon: UiSilkIcons applicationGoIcon.
	
	self ui addCategoryButton buttonStyle: #iconOnly; icon: UiFugueIcons plusIcon; autoRaise: true.
	self ui removeCategoryButton buttonStyle: #iconOnly; icon: UiFugueIcons minusIcon; autoRaise: true.

	self ui resetButton icon: UiSilkIcons bombIcon.
	self ui updateButton icon: UiSilkIcons pageRefreshIcon.! !

!PSControlPanel methodsFor: 'initialize' stamp: 'mt 9/8/2010 10:48:39.648'!
release
	"Callback when window is closed."
! !

!PSControlPanel methodsFor: 'actions' stamp: 'mt 9/10/2010 11:19:19.585'!
removePackage

	self ui categoryList currentItem ifNotNil: [:item |
		"TODO"].! !

!PSControlPanel methodsFor: 'updating - category list' stamp: 'mt 9/10/2010 11:31:24.945'!
removePackage: aPackageName

	self updateLocalInfo.! !

!PSControlPanel methodsFor: 'updating - remote list' stamp: 'mt 9/9/2010 09:53:59.723'!
removeRemoteClient: aRemoteClient

	self updateRemoteInfo.! !

!PSControlPanel methodsFor: 'accessing' stamp: 'mt 9/10/2010 11:41:10.627'!
ui

	^ ui ifNil: [ui := PSControlPanelUi new].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/10/2010 11:34:00.442'!
updateLocalInfo

	self ui categoryList clear.
	self ui addCategoryButton disconnectSignal: #clicked:.
	self ui removeCategoryButton disconnectSignal: #clicked:.

	PSLocalClient instance sourceCode ifNotNil: [:src |
		src packages do: [:pkg | self ui categoryList addText: pkg].
		
		src disconnectSignal: #packageAdded: from: self.
		src disconnectSignal: #packageRemoved: from: self.
		
		self connect: src signal: #packageAdded: toSelector: #addPackage:.
		self connect: src signal: #packageRemoved: toSelector: #removePackage:.
		
		self connect: self ui addCategoryButton signal: #clicked: toSelector: #addPackage.
		self connect: self ui removeCategoryButton signal: #clicked: toSelector: #removePackage.
		].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/9/2010 09:53:31.56'!
updateRemoteInfo

	self ui remoteList clear.

	PSLocalClient instance isConnected
		ifTrue: [
			PSLocalClient instance remoteClients do: [:rc |
				self ui remoteList addText: rc sourceCode uuid asString].

			PSLocalClient instance disconnectSignal: #remoteClientAdded: from: self.
			PSLocalClient instance disconnectSignal: #remoteClientRemoved: from: self.
			
			self connect: PSLocalClient instance signal: #remoteClientAdded: toSelector: #addRemoteClient:.
			self connect: PSLocalClient instance signal: #remoteClientRemoved: toSelector: #removeRemoteClient:].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 11:13:47.97'!
updateServerInfo

	PSLocalClient instance isConnected
		ifTrue: [
			self ui serverLabel text: '<b>Server</b> connected.' asHtmlText.
			self ui connectButton disconnectSignal: #clicked:.
			self ui connectButton
				icon: UiSilkIcons disconnectIcon;
				text: 'Disconnect'.
			self connect: self ui connectButton signal: #clicked: toSelector: #disconnectFromServer.
			]
		ifFalse: [
			self ui serverLabel text: '<b>Server</b> disconnected.' asHtmlText.
			self ui connectButton disconnectSignal: #clicked:.
			self ui connectButton
				icon: UiSilkIcons connectIcon;
				text: 'Connect'.
			self connect: self ui connectButton signal: #clicked: toSelector: #connectToServer.
			].! !

!PSControlPanel methodsFor: 'updating' stamp: 'mt 9/8/2010 11:19:03.483'!
updateUuidLabel: aUUID

	self ui uuidLabel text: aUUID asString.! !

WorldState subclass: #PSRemoteWorldState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteWorldState commentStamp: 'mt 9/7/2010 12:14:23.771' prior: 0!
I have my own queue with deferred UI messages. My dynamic scope is changed to the remote client of the corresponding remote world in EVERY update cycle.!

!PSRemoteWorldState methodsFor: 'update cycle' stamp: 'mt 9/7/2010 12:12:23.233'!
doOneCycleFor: aRemoteWorld

	PSCurrentRemoteClient
		value: aRemoteWorld remoteClient
		during: [super doOneCycleFor: aRemoteWorld].! !

DynamicVariable subclass: #PSCurrentRemoteClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSCurrentRemoteClient commentStamp: 'mig 9/8/2010 11:40:31.429' prior: 0!
I am a dynamic variable that holds the active PSRemoteClient, or nil if working locally.!

DynamicVariable subclass: #PSReplicateSystemEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Network'!

TestCase subclass: #PSBasicTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSBasicTestCase methodsFor: 'tests' stamp: 'mig 8/9/2010 15:22:47.123'!
test01new

	| sut |
	sut := PSSystemDictionary new.

	self assert: sut size equals: Smalltalk globals size.
	Smalltalk globals keysAndValuesDo: [:key :value |
		self assert: value == (sut at: key)].
! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mig 8/10/2010 13:59:49.758'!
test02proxy

	| testCase sut root |
	
	sut := PSSystemDictionaryProxy new.
	root := Smalltalk globals.
	
	testCase := Smalltalk globals at: #TestCase.
	
	sut install.
	self assert: sut == Smalltalk globals.
	self assert: testCase == (Smalltalk globals at: #TestCase).
	sut uninstall.
	self assert: root == Smalltalk globals.! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mt 8/30/2010 11:55:22.347'!
test03proxyWithOrganization

	PSSystemDictionaryProxy install.
	
	self
		assert: Smalltalk globals isProxy;
		assert: SystemOrganization isProxy.
		
	PSSystemDictionaryProxy uninstall.
	
	self
		deny: Smalltalk globals isProxy;
		deny: SystemOrganization isProxy.! !

TestCase subclass: #PSModelTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/10/2010 11:16:19.694'!
test01snapshots

	| src clt |
	clt := PSRemoteClient new.
	src := PSSourceCode new.

	PSSystemDictionaryProxy install.
	clt sourceCode: src.
	PSSystemDictionaryProxy uninstall.
	
	src addPackage: #PolySource.
		
	self assert: src snapshot isNil.
	
	clt updateSnapshot.
	
	self
		assert: clt sourceCode categories size equals: src snapshot size;
		assert: (src snapshot includesKey: #'PolySource-Core');
		assert: (src snapshot includesKey: #'PolySource-Model');
		assert: (src snapshot associations first value isString).
		
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:39.092'!
test02classAddedEvent

	| evt upd |
	evt := AddedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String definition equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:47.941'!
test03classModifiedEvent

	| evt upd |
	evt := ModifiedClassDefinitionEvent classDefinitionChangedFrom: String to: Integer.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: Integer name equals: upd eventItemClass;
		assert: Integer definition equals: upd event item;
		assert: String name equals: upd event oldItem.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:53.435'!
test04classRemovedEvent

	| evt upd |
	evt := RemovedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String name equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:07:59.233'!
test05classRenamedEvent

	| evt upd |
	evt := RenamedEvent class: String category: #'Collections-Strings' oldName: #String newName: #NewString.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String name equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:06.033'!
test06classCommentedEvent

	| evt upd |
	evt := CommentedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String comment equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:11.905'!
test07classRecategorizedEvent

	| evt upd |
	evt := RecategorizedEvent class: String category: #Foobar oldCategory: #'Collections-Strings'.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String name equals: upd event item.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 11:09:29.308'!
test08classReorganizedEvent

	| evt upd |
	evt := ReorganizedEvent item: String kind: #class.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: String organization asString equals: upd event item.! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:28.143'!
test09methodAddedEvent

	| evt upd |
	evt := AddedEvent item: String>>#stringhash kind: #method.
	evt itemClass: String.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #stringhash equals: upd eventItemMethod;
		assert: (upd event item includesSubString: evt item getSource).
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:34.248'!
test10methodModifiedEvent

	| evt upd |
	evt := ModifiedEvent methodChangedFrom: String>>#stringhash to: String>>#withCRs selector: #withCRs inClass: String.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #withCRs equals: upd eventItemMethod;
		assert: #stringhash equals: upd event oldItem;
		assert: (upd event item includesSubString: evt item getSource).
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 11:23:34.906'!
test11methodRecategorizedEvent

	| evt upd |
	evt := RecategorizedEvent method: String>>#withCRs protocol: #testing class: String oldProtocol: #printing. 
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #withCRs equals: upd eventItemMethod;
		assert: #withCRs equals: upd event item;
		assert: #testing equals: upd event itemProtocol;
		assert: #printing equals: upd event oldCategory.
	! !

!PSModelTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:08:47.352'!
test12methodRemovedEvent

	| evt upd |
	evt := RemovedEvent item: String>>#stringhash kind: #method.
	evt itemClass: String.
	upd := PSSourceCodeClient createUpdateFromEvent: evt.
	
	self
		assert: String name equals: upd eventItemClass;
		assert: #stringhash equals: upd eventItemMethod;
		assert: #stringhash equals: upd event item.
	! !

TestCase subclass: #PSNetworkTestCase
	instanceVariableNames: 'srv clt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSNetworkTestCase methodsFor: 'running' stamp: 'mt 9/6/2010 11:10:43.548'!
setUp

	super setUp.
	
	srv := SyServer new start.
	clt := PSLocalClient new
		connection: (SyClient new connectToHostNamed: 'localhost' port: 22701).! !

!PSNetworkTestCase methodsFor: 'running' stamp: 'mt 8/30/2010 15:54:46.481'!
tearDown

	super tearDown.

	clt connection disconnect.

	srv stop.
	srv repository clear.
! !

!PSNetworkTestCase methodsFor: 'tests' stamp: 'mig 9/8/2010 11:24:33.903'!
test01uuid

	| src |

	self
		assert: (src := clt sourceCode) notNil;
		assert: clt uuid equals: src uuid.
	
	
! !

TestCase subclass: #PSProxiedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSProxiedTestCase methodsFor: 'running' stamp: 'mt 8/29/2010 19:41:49.115'!
setUp

	super setUp.
	PSSystemDictionaryProxy install.! !

!PSProxiedTestCase methodsFor: 'running' stamp: 'mig 8/10/2010 14:00:41.469'!
tearDown

	Smalltalk globals uninstall.
	super tearDown.
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 9/6/2010 11:37:49.751'!
test01environment

	| newRemoteClient |
	newRemoteClient := PSRemoteClient new.
	
	PSCurrentRemoteClient value: newRemoteClient during: [
		self assert: Object environment yourself == newRemoteClient systemDictionary].
	self deny: Object environment yourself == newRemoteClient systemDictionary.
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 9/6/2010 11:37:08.187'!
test02newClasses

	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
	
	PSCurrentRemoteClient value: PSRemoteClient new during: [
		"Create a class and a subclass of it."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		(Smalltalk at: #PSFoobar)
			subclass: #PSFoobar2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		self assert: (Smalltalk includesKey: #PSFoobar).
		self assert: (Smalltalk includesKey: #PSFoobar2)].
	
	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 9/6/2010 11:36:53.926'!
test03evaluate

	self deny: (Smalltalk includesKey: #PSFoobar).
	
	PSCurrentRemoteClient value: PSRemoteClient new during: [
		"Create a class and instantiate it once."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		self
			shouldnt: [Compiler evaluate: 'PSFoobar new']
			raise: MessageNotUnderstood].
		
	self
		should: [Compiler evaluate: 'PSFoobar new']
		raise: MessageNotUnderstood.
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 8/29/2010 19:56:47.815'!
test05proxyTest

	PSSystemDictionaryProxy uninstall.
	self deny: Smalltalk globals isProxy.

	PSSystemDictionaryProxy install.
	self assert: Smalltalk globals isProxy.! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mig 9/7/2010 09:57:21.031'!
test06organization

	PSCurrentRemoteClient value: PSRemoteClient new during: [
		| foobar foobar2 |
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		foobar := Compiler evaluate: 'PSFoobar'.
		foobar subclass: #PSFoobar2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		foobar2 := Compiler evaluate: 'PSFoobar2'.
		self assert: #'PolySource-Tests-Temporary' equals: foobar category.
		self assert: #'PolySource-Tests-Temporary' equals: foobar2 category.
	].! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 9/9/2010 10:21:09.763'!
test07newRemoteClientError

	PSCurrentRemoteClient value: #foobar during: [
		self should: [PSRemoteClient new] raise: Error].
	
	self shouldnt: [PSRemoteClient new] raise: Error.! !

ProtoObject subclass: #PSSystemDictionaryProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionaryProxy commentStamp: 'mig 9/8/2010 11:42:22.872' prior: 0!
I am a proxy for the system dictionary, ie. 'Smalltalk globals'.!

!PSSystemDictionaryProxy class methodsFor: 'installation' stamp: 'mig 8/9/2010 17:42:02.667'!
install

	self new install.! !

!PSSystemDictionaryProxy class methodsFor: 'installation' stamp: 'mig 8/9/2010 17:42:35.209'!
uninstall

	Smalltalk globals uninstall.! !

!PSSystemDictionaryProxy methodsFor: 'proxy' stamp: 'mt 9/6/2010 11:44:05.53'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: (PSCurrentRemoteClient value
		ifNil: [original]
		ifNotNil: [PSCurrentRemoteClient value systemDictionary])! !

!PSSystemDictionaryProxy methodsFor: 'installation' stamp: 'mt 9/9/2010 14:57:34.925'!
install

	self isInstalled ifTrue: [^self].

	original := Smalltalk globals.
	Smalltalk instVarNamed: #globals put: self.
	
	"Add a proxy for the organization too."
	PSSystemOrganizerProxy install.
! !

!PSSystemDictionaryProxy methodsFor: 'testing' stamp: 'mig 8/9/2010 15:14:19.08'!
isInstalled

	^ Smalltalk globals == self! !

!PSSystemDictionaryProxy methodsFor: 'testing' stamp: 'mt 8/29/2010 19:32:19.736'!
isProxy

	^ true! !

!PSSystemDictionaryProxy methodsFor: 'installation' stamp: 'mt 9/9/2010 14:57:39.947'!
uninstall

	self isInstalled ifFalse: [^self].

	Smalltalk instVarNamed: #globals put: original.
	original := nil.
	
	"Remove proxy for organization."
	PSSystemOrganizerProxy uninstall.! !

ProtoObject subclass: #PSSystemOrganizerProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemOrganizerProxy commentStamp: 'mig 9/8/2010 11:42:10.656' prior: 0!
I am a proxy for the system organizer, ie. 'Smalltalk organization'.
DO NOT install me directly but use "PSSystemDictionaryProxy install" instead.!

!PSSystemOrganizerProxy class methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:37:54.726'!
install

	self new install.! !

!PSSystemOrganizerProxy class methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:38:13.074'!
uninstall

	SystemOrganization uninstall.! !

!PSSystemOrganizerProxy methodsFor: 'proxy' stamp: 'mt 9/6/2010 11:43:40.372'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: (PSCurrentRemoteClient value 
		ifNil: [original]
		ifNotNil: [PSCurrentRemoteClient value systemOrganization])! !

!PSSystemOrganizerProxy methodsFor: 'installation' stamp: 'mt 8/30/2010 11:37:01.302'!
install

	self isInstalled ifTrue: [^self].

	original := SystemOrganization.
	Smalltalk at: #SystemOrganization put: self.
! !

!PSSystemOrganizerProxy methodsFor: 'testing' stamp: 'mt 8/30/2010 11:37:27.065'!
isInstalled

	^ SystemOrganization == self! !

!PSSystemOrganizerProxy methodsFor: 'testing' stamp: 'mt 8/30/2010 11:29:56.853'!
isProxy

	^ true! !

!PSSystemOrganizerProxy methodsFor: 'installation' stamp: 'mt 8/30/2010 11:37:15.148'!
uninstall

	self isInstalled ifFalse: [^self].
	
	Smalltalk at: #SystemOrganization put: original.
	original := nil.! !

MorphicProject subclass: #PSRemoteProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Morphic'!

!PSRemoteProject commentStamp: 'mt 9/7/2010 12:15:12.813' prior: 0!
A remote projecte has a remote world. ;)!

!PSRemoteProject methodsFor: 'initialize' stamp: 'mt 9/7/2010 10:57:24.923'!
initialize

	self perform: #initialize withArguments: #() inSuperclass: Project.

	world := PSRemoteWorld newWorldForProject: self.
	Locale switchToID: CurrentProject localeID.
	Preferences useVectorVocabulary ifTrue: [world installVectorVocabulary]
	! !

!PSRemoteProject methodsFor: 'accessing' stamp: 'mt 9/7/2010 13:09:47.222'!
name

	^ self world remoteClient
		ifNil: ['nil']
		ifNotNil: [self world remoteClient name]! !
